//Class taskElement
//Represents a task link on the screen.
// spanId: ID for the span surrounding the link
// str: String ID for LoadString to show for the link
// action: action to evaluate when clicking on the link
// shouldDraw: true to draw in page, false if it already exists in page
// isLink: true if its a link, false otherwise
// parentTask: ID of parent task (if applicable)
function taskElement(spanid,str,action,shouldDraw,isLink,parentTask) //mm26Jun03
{ 
   this.spanid=spanid;
   this.focusid=spanid + "_FOCUS";
   this.str=str;
   this.parentTask = parentTask;
   if(isLink)
   {
      if(shouldDraw)
      { 
         document.write("<SPAN id="+spanid+ " class=hidden><A HREF='' id=\""+ spanid + "_FOCUS" + "\" onclick=\"SetCurrentHighlightIndexToId('" + spanid + "');" + action + "\" class=normal>" + LoadString(str) + "</A><BR><BR></SPAN>"); 
      }
      this.spanElement=document.getElementById(spanid);
      this.focusElement=document.getElementById(spanid + "_FOCUS");
      this.action=action;
      this.isVisible=false;
      this.focusElement.onfocus=highlight;
      this.focusElement.onblur=unhighlight;      
   }
   else //mm26Jun03
   {
      document.write("<SPAN id="+spanid+ " class=hidden>" + LoadString(str) + "<BR><BR></SPAN>");
      this.spanElement=document.getElementById(spanid);
      this.focusElement="";
      this.focusElement.onfocus="";
      this.focusElement.onblur="";
      this.action="return false";
      this.isVisible=false;
   }
}

ta=new Array();
ta['CONTROLLER_SETTINGS']        =new taskElement('CONTROLLER_SETTINGS'        ,"PX_TAG_CONTROLLER_SETTINGS"           ,"return SubmitForm(document.ndlForm,'choice','AV-CS-00.htm',userTag,focusTag);"  ,true,true);
ta['REDUNDANT_SETTINGS']         =new taskElement('REDUNDANT_SETTINGS'          ,"PX_TAG_REDUNDANT_SETTINGS"             ,"return SubmitForm(document.ndlForm,'choice','AV-RS-00.htm',userTag,focusTag);"  ,true,true);
ta['LDRIVE_ACCELERATOR_SETTINGS']=new taskElement('LDRIVE_ACCELERATOR_SETTINGS',"PX_TAG_AV_LDRIVE_ACCELERATOR_SETTINGS","return SubmitForm(document.ndlForm,'choice','AV-LDCS-00.htm',userTag,focusTag);",true,true);
ta['CREATE_ARRAY']               =new taskElement('CREATE_ARRAY'               ,"PX_TAG_AV_CREATE_ARRAY"               ,"return SubmitForm(document.ndlForm,'choice','AV-CA-00.htm',userTag,focusTag);"  ,true,true);
ta['SSPV2_SETTINGS']             =new taskElement('SSPV2_SETTINGS'             ,"PX_TAG_AV_SSP"                        ,"return SubmitForm(document.ndlForm,'choice','AV-SPV2-00.htm',userTag,focusTag);",true,true);
ta['CLEAR_CONFIG']               =new taskElement('CLEAR_CONFIG'               ,"PX_TAG_AV_CLEAR_CONFIG"               ,"return AdvancedClearConfig();"                                                  ,true,true);
ta['AV_FLASH_FIRMWARE']          =new taskElement('AV_FLASH_FIRMWARE'          ,"PX_STR_AV_FLASH_FIRMWARE"             ,"return SubmitForm(document.ndlForm,'choice','AV-FF-00.htm',userTag,focusTag);"  ,true,true);
ta['CREATE_LDRIVE']              =new taskElement('CREATE_LDRIVE'              ,"PX_TAG_AV_CREATE_LDRIVE"              ,"return SubmitForm(document.ndlForm,'choice','AV-CD-00.htm',userTag,focusTag);"  ,true,true);
ta['CREATE_RESOURCE_VOLUME']     =new taskElement('CREATE_RESOURCE_VOLUME'     ,"PX_TAG_AV_CREATE_RESOURCE_VOLUME"     ,"return SubmitForm(document.ndlForm,'choice','AV-CRV-00.htm',userTag,focusTag);" ,true,true);
ta['EXPAND_ARRAY']               =new taskElement('EXPAND_ARRAY'               ,"PX_TAG_AV_EXPAND_ARRAY"               ,"return SubmitForm(document.ndlForm,'choice','AV-EA-00.htm',userTag,focusTag);"  ,true,true);
ta['ADD_SPARE']                  =new taskElement('ADD_SPARE'                  ,"PX_TAG_AV_ASSIGN_SPARE"               ,"return SubmitForm(document.ndlForm,'choice','AV-AS-00.htm',userTag,focusTag);"  ,true,true);
ta['DROP_SPARE']                 =new taskElement('DROP_SPARE'                 ,"PX_TAG_AV_REMOVE_SPARE"               ,"return AdvancedRemoveSpareArray();"                                             ,true,true);
if (GetData("isOnSmartStart")) //Uncomment this to only allow Split/Resync Mirror to run offline
   {
   ta['SPLIT_ARRAY']                =new taskElement('SPLIT_ARRAY'                ,"PX_TAG_AV_SPLIT_ARRAY"                ,"return AdvancedSplitArray();"                                                   ,true,true);
   ta['RESYNC_ARRAY']               =new taskElement('RESYNC_ARRAY'               ,"PX_TAG_AV_RESYNC_ARRAY"               ,"return SubmitForm(document.ndlForm,'choice','AV-RA-00.htm',userTag,focusTag);"  ,true,true);
   }
ta['SPARE_MANAGEMENT']           =new taskElement('SPARE_MANAGEMENT'           ,"PX_TAG_AV_SPARE_MANAGEMENT"           ,"return SubmitForm(document.ndlForm,'choice','AV-SM-00.htm',userTag,focusTag);"  ,true,true);
ta['DELETE_ARRAY']               =new taskElement('DELETE_ARRAY'               ,"PX_TAG_DELETE"                        ,"return AdvancedDeleteArray();"                                                  ,true,true);
ta['MIGRATE_LDRIVE']             =new taskElement('MIGRATE_LDRIVE'             ,"PX_TAG_AV_MIGRATE_LDRIVE"             ,"return SubmitForm(document.ndlForm,'choice','AV-MD-00.htm',userTag,focusTag);"  ,true,true);
ta['EXTEND_LDRIVE']              =new taskElement('EXTEND_LDRIVE'              ,"PX_TAG_AV_EXTEND_LDRIVE"              ,"return SubmitForm(document.ndlForm,'choice','AV-XD-00.htm',userTag,focusTag);"  ,true,true);
ta['SSPV1_SETTINGS']             =new taskElement('SSPV1_SETTINGS'             ,"PX_TAG_AV_SSP"                        ,"return SubmitForm(document.ndlForm,'choice','AV-SP-00.htm',userTag,focusTag);"  ,true,true);
ta['DELETE_LDRIVE']              =new taskElement('DELETE_LDRIVE'              ,"PX_TAG_DELETE"                        ,"return AdvancedDeleteLogicalDrive();"                                           ,true,true);
ta['REENABLE_LDRIVE']            =new taskElement('REENABLE_LDRIVE'            ,"PX_TAG_AV_REENABLE_LDRIVE"            ,"return AdvancedReenableLogicalDrive();"                                         ,true,true);
ta['MORE_INFO']                  =new taskElement('MORE_INFO'                  ,"PX_TAG_MORE_INFO"                     ,"return OpenMoreInfoWindow('infoForm',focusTag,userTag);"                        ,true,true);
ta['NO_TASKS']                   =new taskElement('NO_TASKS'                   ,"PX_TAG_NO_TASKS"                      ,""                                                                               ,true,false);
ta['ADVANCED_CONTROLLER_FEATURES']=new taskElement('ADVANCED_CONTROLLER_FEATURES',"PX_TAG_ADVANCED_FEATURES"           ,"return ShowTasksFor(controllerFocus,focusTag,userTag,existingTasks + ',BACK_TO_STANDARD_TASKS','ADVANCED_CONTROLLER_FEATURES');",true,true);
//the following tasks are a part of the Advanced Controller Features sub-task page
ta['PDRIVE_WRITE_CACHE_SETTINGS']=new taskElement('PDRIVE_WRITE_CACHE_SETTINGS',"PX_TAG_PDRIVE_WRITE_CACHE_SETTINGS"   ,"return SubmitForm(document.ndlForm,'choice','AV-PDWC-00.htm',userTag,focusTag);",true,true,'ADVANCED_CONTROLLER_FEATURES');
ta['DISABLE_STANDBY_CONTROLLER'] =new taskElement('PDRIVE_DISABLE_STANDY_CONTROLLER',"PX_TAG_DISABLE_STANDBY_CONTROLLER","return AdvancedDisableStandbyController();"                                    ,true,true,'ADVANCED_CONTROLLER_FEATURES');
ta['BACK_TO_STANDARD_TASKS']     =new taskElement('BACK_TO_STANDARD_TASKS'     ,"PX_TAG_BACK_TO_STANDARD_TASKS"         ,"return ShowTasksFor(controllerFocus,focusTag,userTag,existingTasks);"          ,true,true,'ADVANCED_CONTROLLER_FEATURES');

function ShowHideWizards()
{
   if (ta["LB_UNCONFIGURED"]&&ta["LB_CONFIGURED"]&&ta["UB_CONFIG"])
   {
      wizardsElement = document.getElementById("WIZARDS");
      if (ta["LB_UNCONFIGURED"].isVisible || ta["LB_CONFIGURED"].isVisible || ta["UB_CONFIG"].isVisible)
      {
         wizardsElement.style.display="inline";
      }
      else 
      {
         wizardsElement.style.display="none";
      } 
   }
}

//ShowTasksFor
//Shows tasks for passed in parameters
//controllerFocusIn: controller focus
//focusIn: current device focus
//userIn: current user id
//tasks: list of tasks to show
//parentTask: if this is set, only show the tasks in the tasks array that have this parent
//            This allows hierarchical task pages to be created easily
function ShowTasksFor(controllerFocusIn,focusIn,userIn,tasks,parentTask)
{
   controllerFocus = controllerFocusIn;
   oldTasks = existingTasks.split(",");
   if(oldTasks != "")
   {
      for (var i=0;i<oldTasks.length;++i)
      {
         if(ta[oldTasks[i]])
         {
            ta[oldTasks[i]].spanElement.style.display="none";
            ta[oldTasks[i]].isVisible=false;
         }
      }
   }
  
   // If we're dealing with unused space send the 
   // array id instead. Unused space is a subset of 
   // array functionality.             - mm26Jun03
   var sTemp = new String(focusIn);
   if(sTemp.substr(sTemp.length - 2, 2) == "US")
   {
      sTemp = sTemp.substr(0, sTemp.length - 2);
   }
   focusTag=sTemp;
  
   //focusTag=focusIn;
   userTag=userIn;
   newTasks=tasks.split(",");
   if (parent.config)
   {
      if (parent.config.oa[focusIn])
      {
         elementText=parent.config.oa[focusIn].highlightelement.innerHTML;
         elementText=elementText.replace("<script>","<!--");
         elementText=elementText.replace("<SCRIPT>","<!--");
         elementText=elementText.replace("<\/script>","-->");
         elementText=elementText.replace("<\/SCRIPT>","-->");
         e=document.getElementById("ELEMENT_TEXT");
         if(e)
         {
            e.innerHTML = elementText;
         }
      }
   }

   for (var i=0;i<newTasks.length;++i)
   {
      if(ta[newTasks[i]])
      {
      //only show the task if the parent tasks match.
      //Note: if parentTask is undefined and the parent task for the task is
      //undefined, the task will be displayed since it is a root level task.
         if (ta[newTasks[i]].parentTask == parentTask)
            {
            ta[newTasks[i]].spanElement.style.display="inline";
            ta[newTasks[i]].isVisible=true;
            }
      }
   }
   existingTasks = tasks;
   ShowImageLinks();
   ShowHideWizards();

   if (idArray)
      {
      maxIndex = idArray.length -1;
      currentHighlightIndex=0;

      while( (currentHighlightIndex < maxIndex) &&
            !idArray[currentHighlightIndex].isVisible)
         {
            ++currentHighlightIndex;
         }
      }

   //mm26Jun03
   if(newTasks == "")
   {
      ta['MORE_INFO'].spanElement.style.display="inline";
      ta['MORE_INFO'].isVisible=true;
      existingTasks = 'MORE_INFO';
   }
return false;
}

function ShowImageLinks()
{
   refreshElement=document.getElementById("REFRESH");
   discardElement=document.getElementById("DISCARD");
   warnElement=document.getElementById("warning");
   errorElement=document.getElementById("error");
   infoElement=document.getElementById("info");
   saveElement=document.getElementById("SAVE");
   isSavePossible = parent.config.isSavePossible;
   errorLevel = parent.config.errorLevel;
   if (refreshElement && discardElement && warnElement && errorElement &&
      infoElement && saveElement && ta["DISCARD"] && ta["REFRESH"] && ta["SAVE"])
   {
      if (isSavePossible)
      {
         refreshElement.style.display="none";
         discardElement.style.display="inline";
         saveElement.style.display="inline";
         ta["DISCARD"].isVisible=true;
         ta["REFRESH"].isVisible=false;
         ta["SAVE"].isVisible=true;
      }
      else
      {
         discardElement.style.display="none";
         refreshElement.style.display="inline";
         saveElement.style.display="none";
         ta["DISCARD"].isVisible=false;
         ta["REFRESH"].isVisible=true;
         ta["SAVE"].isVisible=false;
      }

      if (errorLevel == "none")
      {
         errorElement.style.display="none";
         warnElement.style.display="none";
         infoElement.style.display="none";
         ta["warning"].isVisible=false;
         ta["error"].isVisible=false;
         ta["info"].isVisible=false;
      }
      else
      {
         document.getElementById("error").style.display="none";
         document.getElementById("warning").style.display="none";
         document.getElementById("info").style.display="none";
         ta["warning"].isVisible=false;
         ta["error"].isVisible=false;
         ta["info"].isVisible=false;
         toShow=document.getElementById(errorLevel);
         if(toShow)
         {
            toShow.style.display="inline";
            ta[errorLevel].isVisible=true;
         }
      }
   }
}

function Blink()
{
if (document.blinkForm)
 {
 document.blinkForm.FOCUS.value=focusTag;
 document.blinkForm.TAG.value=userTag;
 document.blinkForm.submit();
 }
}


var currentHighlightIndex=-1;
function SetCurrentHighlightIndexToId(id)
 {
 if (ta[id]){currentHighlightIndex=ta[id].index;}
 }


urlArgs = urlArguments();
if (urlArgs.F){focusTag=urlArgs.F;}
if (urlArgs.U){userTag=urlArgs.U;}
if (urlArgs.T){existingTasks=urlArgs.T;}
if (urlArgs.CF){controllerFocus=urlArgs.CF;}

if ( GetTaskData("savingConfiguration") )
{SetTaskData("savingConfiguration", false);
SubmitDataForm("discoverForm","disc","CC-00.htm",userTag,focusTag);}

var saveMessage = LoadString("PX_TAG_UB_SAVE_MESSAGE");
var discardMessage = LoadString("PX_TAG_DISCARD_WARNING");
var mainMenuMessage = LoadString("PX_TAG_MAIN_MENU_WARNING");
var refreshString = LoadString("PX_TAG_REFRESH");
var discardString = LoadString("PX_TAG_DISCARD");

var taskComplete = true;

function ValidateAV00()
  {
  var shouldReturnToMain = false;
  var retValue = false;
  if ( parent.config.isSavePossible || 
       parent.config.hasEmptyArrays )
     {
     if ( confirm(mainMenuMessage) )
       {
       shouldReturnToMain = true;
       }
     }
   else
     {
     shouldReturnToMain = true;
     }

  if (shouldReturnToMain)
    {
    discoverPage = GetDiscoveryFrame();
    if (discoverPage.ReturnToMain)
      {
      discoverPage.ReturnToMain(controllerFocus,userTag,"AV-00" );
      }
    }
  return false;
  }

function RunWizard(wizardPage)
  {
  discoverPage = GetDiscoveryFrame();
  if (discoverPage.ReturnToMain)
    {
    discoverPage.ReturnToMain(controllerFocus,userTag,"AV-00",wizardPage);
    }
  return false;
  }

function AdvancedClearConfig()
   {
   if (taskComplete)
     {
     taskComplete = false;
     document.advancedLdriveInfoForm.FOCUS.value=focusTag;
     document.advancedLdriveInfoForm.TAG.value=userTag;
     document.advancedLdriveInfoForm.submit();
     parent.AdvancedData1.isDataReady = false;
     WaitForAndExecute("parent.AdvancedData1.isDataReady", "ConfirmAndClearConfig()", 250)
     }
   return false;
   }

function ConfirmAndClearConfig()
   {
   TransferDataFromTo("isConfigured", parent.AdvancedData1, this);
   TransferDataFromTo("hasPartitions", parent.AdvancedData1, this);
   TransferDataFromTo("hasSWVRSectors", parent.AdvancedData1, this);
   var clearConfigMessage;

   shouldClear = !isConfigured;

   if ( isConfigured )
      {
      clearConfigMessage = LoadString("PX_TAG_AV_CLEAR_CONFIG_DELETE_LDRIVE") + "\r\n\r\n";
      if ( hasPartitions )
         {
         clearConfigMessage += LoadString("PX_TAG_AV_CLEAR_CONFIG_DELETE_LDRIVE_PARTITION") + "\r\n\r\n";
         }
      if ( hasSWVRSectors )
         {
         clearConfigMessage += LoadString("PX_TAG_AV_CLEAR_CONFIG_DELETE_LDRIVE_SWVR") + "\r\n\r\n";
         }
      clearConfigMessage += LoadString("PX_TAG_OK_CANCEL");

      shouldClear = confirm( clearConfigMessage );
      }
  
   if (shouldClear)
      {
      document.AV_CC_FORM.FOCUS.value=focusTag;
      document.AV_CC_FORM.TAG.value=userTag;
      document.AV_CC_FORM.submit();
      }
   else
      {
      taskComplete = true;
      }

   parent.AdvancedData1.location = "ACUBlank.htm";
   return false;
   }

function AdvancedDeleteArray()
   {
   if (taskComplete)
     {
     taskComplete = false;
     document.advancedLdriveInfoForm.FOCUS.value=focusTag;
     document.advancedLdriveInfoForm.TAG.value=userTag;
     document.advancedLdriveInfoForm.submit();
     parent.AdvancedData1.isDataReady = false;
     WaitForAndExecute("parent.AdvancedData1.isDataReady", "ConfirmAndDeleteArray()", 250)
     }
   return false;
   }

function ConfirmAndDeleteArray()
   {
   TransferDataFromTo("isConfigured", parent.AdvancedData1, this);
   TransferDataFromTo("hasPartitions", parent.AdvancedData1, this);
   TransferDataFromTo("hasSWVRSectors", parent.AdvancedData1, this);
   var deleteMessage;

   shouldDelete = !isConfigured;

   if ( isConfigured )
      {
      deleteMessage = LoadString("PX_TAG_AV_DELETE_ARRAY") + "\r\n\r\n";
      if ( hasPartitions )
         {
         deleteMessage += LoadString("PX_TAG_AV_DELETE_ARRAY_PARTITION") + "\r\n\r\n";
         }
      if ( hasSWVRSectors )
         {
         deleteMessage += LoadString("PX_TAG_AV_DELETE_ARRAY_SWVR") + "\r\n\r\n";
         }
      deleteMessage += LoadString("PX_TAG_OK_CANCEL");

      shouldDelete = confirm( deleteMessage );
      }
  
   if (shouldDelete)
      {
      document.AV_DA_FORM.FOCUS.value=focusTag;
      document.AV_DA_FORM.TAG.value=userTag;
      document.AV_DA_FORM.DELETE_ARRAY.value=focusTag;
      document.AV_DA_FORM.submit();
      }
   else
      {
      taskComplete = true;
      }

   parent.AdvancedData1.location = "ACUBlank.htm";
   return false;
   }

function AdvancedRemoveSpareArray()
   {
   document.AV_RS_FORM.FOCUS.value=focusTag;
   document.AV_RS_FORM.TAG.value=userTag;
   document.AV_RS_FORM.submit();
   return false;
   }

function AdvancedSplitArray()
   {
   if (taskComplete)
     {
     taskComplete=false;
     document.AV_SA_FORM.FOCUS.value=focusTag;
     document.AV_SA_FORM.TAG.value=userTag;
     document.AV_SA_FORM.submit();
     }
   return false;
   }

function AdvancedDeleteLogicalDrive()
   {
   if (taskComplete)
     {
     taskComplete = false;
     document.advancedLdriveInfoForm.FOCUS.value=focusTag;
     document.advancedLdriveInfoForm.TAG.value=userTag;
     document.advancedLdriveInfoForm.submit();
     parent.AdvancedData1.isDataReady = false;
     WaitForAndExecute("parent.AdvancedData1.isDataReady", "ConfirmAndDeleteLogicalDrive()", 250)
     }
   return false;
   }

function AdvancedReenableLogicalDrive()
   {
   if (taskComplete)
     {
     taskComplete=false;
     if (confirm(LoadString("PX_TAG_AV_WARN_REENABLE_LDRIVE")))
       {
       document.AV_RD_FORM.FOCUS.value=focusTag;
       document.AV_RD_FORM.TAG.value=userTag;
       document.AV_RD_FORM.submit();
       }
     else
        {
        taskComplete=true;
        }
     }
   return false;
   }

function ConfirmAndDeleteLogicalDrive()
   {
   TransferDataFromTo("isConfigured", parent.AdvancedData1, this);
   TransferDataFromTo("hasPartitions", parent.AdvancedData1, this);
   TransferDataFromTo("hasSWVRSectors", parent.AdvancedData1, this);

   shouldDelete = !isConfigured;

   if ( isConfigured )
     {
     var deleteMessage = LoadString("PX_TAG_AV_DELETE_LDRIVE") + "\r\n\r\n";
     if ( hasPartitions )
       {
       deleteMessage += LoadString("PX_TAG_AV_DELETE_LDRIVE_PARTITION") + "\r\n\r\n";
       }
     if ( hasSWVRSectors )
       {
       deleteMessage += LoadString("PX_TAG_AV_DELETE_LDRIVE_SWVR") + "\r\n\r\n";
       }
     deleteMessage += LoadString("PX_TAG_OK_CANCEL");
     shouldDelete = confirm( deleteMessage );
     }

   if ( shouldDelete  )
      {
      document.AV_DD_FORM.FOCUS.value=focusTag;
      document.AV_DD_FORM.TAG.value=userTag;
      document.AV_DD_FORM.DELETE_LDRIVE.value=focusTag;
      document.AV_DD_FORM.submit();
      }
   else
      {
      taskComplete = true;
      }

   parent.AdvancedData1.location = "ACUBlank.htm";
   return false;
   }

function AdvancedDisableStandbyController()
   {
   if (taskComplete)
     {
     taskComplete = false;
     if (confirm(LoadString("PX_TAG_DISABLE_STANDBY_CONTROLLER_WARNING")))
        {
        document.AV_DSC_FORM.FOCUS.value=focusTag;
        document.AV_DSC_FORM.TAG.value=userTag;
        document.AV_DSC_FORM.submit();
        }
     else
        {
        taskComplete = true;
        }
     }
   return false;
   }
   
function MoreInfo(){return OpenMoreInfoWindow('infoForm', focusTag, userTag);}

function Refresh()
{
if (document.discardNowForm)
 {
 document.discardNowForm.FOCUS.value=controllerFocus; 
 document.discardNowForm.TAG.value=userTag; 
 if (parent.config.hasEmptyArrays) 
 { return ConfirmAndSubmit(discardMessage, 'discardNowForm','AV-Config.htm','config'); } 
 else if ( parent.config.isSavePossible )
 { return ConfirmAndSubmit(discardMessage,'discardNowForm','AV-Config.htm','config'); }
 else {
 SubmitForm(document.discardNowForm,'config','AV-Config.htm',userTag,controllerFocus); return false;}
 }
}

function Save()
{if (confirm(saveMessage))
 {
 parent.config.hasEmptyArrays = false;
 parent.config.isSavePossible = false;
 SetTaskData("savingConfiguration", true);
 document.startSaveForm.FOCUS.value=controllerFocus;
 document.startSaveForm.TAG.value=userTag;
 document.startSaveForm.submit();
 }
return false;}

function InsertClicked()
 {
 if (ta['CREATE_ARRAY'] &&
     ta['CREATE_LDRIVE'])
  {
  if (ta['CREATE_ARRAY'].isVisible)
    {
    action = ta['CREATE_ARRAY'].action;
    action = action.replace("return","");
    eval(action);
    parent.choice.focus();
    }
  else if (ta['CREATE_LDRIVE'].isVisible)
    {
    action = ta['CREATE_LDRIVE'].action;
    action = action.replace("return","");
    eval(action);
    parent.choice.focus();
    }
  }
 return false;
 }

function DeleteClicked()
 {
 if (ta['CLEAR_CONFIG'] &&
     ta['DELETE_ARRAY'] && 
     ta['DELETE_LDRIVE'])
  {
  if (ta['CLEAR_CONFIG'].isVisible)
   {
   action = ta['CLEAR_CONFIG'].action;
   action = action.replace("return","");
   eval(action);
   }
  else if (ta['DELETE_ARRAY'].isVisible)
   {
   action = ta['DELETE_ARRAY'].action;
   action = action.replace("return","");
   eval(action);
   }
  else if(ta['DELETE_LDRIVE'].isVisible)
   {
   action = ta['DELETE_LDRIVE'].action;
   action = action.replace("return","");
   eval(action);
   }
  }
 }

 function MoreInfo()
 {
 if (ta['MORE_INFO'] )
  {
  if (ta['MORE_INFO'].isVisible)
   {
   action = ta['MORE_INFO'].action;
   action = action.replace("return","");
   eval(action);
   }
  }
 }

 function taskHotKey(task)
 {
 if (ta[task] )
  {
  if (ta[task].isVisible)
   {
   // This line of code prevented the keypress event
   // from being captured in Moz/NS resulting in the 
   // default browser behavior of auto selecting text
   //parent.choice.focus();                           //mm07Sep03
   
   action = ta[task].action;
   action = action.replace("return","");
   eval(action);
   }
  }
 }

function AClicked()
{
 return taskHotKey('CREATE_ARRAY');
}

function BClicked()
{
 return taskHotKey('MIGRATE_LDRIVE');
}

function CClicked()
{
 return taskHotKey('CONTROLLER_SETTINGS');
}

function DClicked()
{
 return taskHotKey('DELETE_LDRIVE');
}

function EClicked()
{
 return taskHotKey('EXPAND_ARRAY');
}

function FClicked()
 {
 return Refresh();
 }

function GClicked()
{
 return taskHotKey('SPARE_MANAGEMENT');
}

function IClicked()
{
 return MoreInfo();
}

function JClicked()
{
 return taskHotKey('DELETE_ARRAY');
}

function KClicked()
{
 if (ta['LICENSE_KEY_CONFIG'])
     {
      if (ta['LICENSE_KEY_CONFIG'].isVisible)
      { 
        return RunWizard('KEY-AA.htm');
      }
     }
}

function LClicked()
{
 return taskHotKey('CREATE_LDRIVE');
}

function MClicked()
 {
 if (parent.config.hasStatusMessages)
  {
  OpenStatusMessagesWindow();
  }
 }

function NClicked()
{
 return taskHotKey('EXTEND_LDRIVE');
}

function OClicked()
{
 return taskHotKey('DROP_SPARE');
}

function PClicked()
{
 if (ta['SSPV2_SETTINGS'] &&
     ta['SSPV1_SETTINGS'])
     {
      if (ta['SSPV2_SETTINGS'].isVisible)
      { 
        return taskHotKey('SSPV2_SETTINGS');
      }
      else if (ta['SSPV1_SETTINGS'].isVisible)
      {
        return taskHotKey('SSPV1_SETTINGS');
      }
     }

}

function QClicked()
{
 if (ta['LB_UNCONFIGURED'] &&
     ta['LB_CONFIGURED'])
     {
      if (ta['LB_UNCONFIGURED'].isVisible)
      { 
        return RunWizard('LB-00.htm');
      }
      else if (ta['LB_CONFIGURED'].isVisible)
      {
        return RunWizard('LB-CC00.htm');
      }
     }
}

function RClicked()
{
 if (ta['REENABLE_LDRIVE'])
     {
      if (ta['REENABLE_LDRIVE'].isVisible)
      { 
        return taskHotKey('REENABLE_LDRIVE');
      }
     }
}

function SClicked()
 {
 if (parent.config.isSavePossible)
  {
  return Save();
  }
 }

function TClicked()
{
 return taskHotKey('LDRIVE_ACCELERATOR_SETTINGS');
}

function UClicked()
{
 return taskHotKey('ADD_SPARE');
}

function WClicked()
{
 if (ta['UB_CONFIG'])
     {
      if (ta['UB_CONFIG'].isVisible)
      { 
        return RunWizard('UB-00.htm');
      }
     }
}

function YClicked()
{
 if (ta['SWITCH_CONFIG'])
     {
      if (ta['SWITCH_CONFIG'].isVisible)
      { 
        return RunWizard('SW-01.htm');
      }
     }
}

function ZClicked()
{
 return taskHotKey('CLEAR_CONFIG');
}